#!/usr/bin/perl

# copyright (c) 1999 by William Brioschi <capo@writeme.com>
# this is free software under GNU General Public License, version 2 or later
# NO WARRANTY is offered; seed COPYING for details

$cfg = "/home/capo/dist/cfg.pl";
do "$cfg" if -e $cfg;

$cmd_binary = "cp";
$cmd_binary = "mv" if ($move =~ /bin/);
$cmd_source = "cp";
$cmd_source = "mv" if ($move =~ /source/);

if ($basepath =~ m:([^/]*/[^/]*)$:) {
	$dist = $1;
} else {
	die "Can't identify distribution from '" . $basepath . "'\n";
}

@must_do_packages = ( );	# fill with "arch:section"
@must_do_sources = ( );		# fill with "section"
# %need_arch = { };		# fill with "arch" => 1
%need_arch = (
	"alpha" => 1,
	"i386" => 1,
	"source" => 1
);
# %db = { };			# fill with "arch:package:property" => value
				#  where arch is arch/source/file
# %packages = { };		# fill with "sec,sub" => ",package,package..."

foreach $ffile (@ARGV) {
	if (! -e $ffile) {
		print "Skipping (not existing) $ffile\n";
		next;
	}

	if ($ffile =~ m:^.*/([^/]*)$:) {
		$file = $1;
	} else {
		$file = $ffile;
	}

	if ($file =~ m/.*\.deb$/) {
		# binary
		$info = `dpkg-deb --info $ffile`;
		if ($info =~ m/^ Package: (.*)$/m) {
			$pack = $1;
		} else {
			print "Skipping (bad) $ffile\n";
			next;
		}
		if ($info =~ m/^ Architecture: (.*)$/m) {
			$arch = $1;
		} else {
			print "Skipping (bad) $ffile\n";
			next;
		}
		if ($info =~ m/^ Version: (.*)$/m) {
			$ver = $1;
		} else {
			print "Skipping (bad) $ffile\n";
			next;
		}
		$binary{$ffile} = $arch . ',' . $ver . ',' . $pack;
		$need_arch{$arch} = 1 if $arch ne "all";
	} else {
		# source
		$source{$ffile} = $file;
		$need_arch{source} = 1;
	}
}

@avl_archs = ( );
while (($arch, $ignore) = each %need_arch) {
	$avl_archs[@avl_archs] = $arch if $arch ne "source";

	print "Processing lists for $arch (in $lists_dir{$arch})\n";

	$ct = 1;
	while ($file = $lists{$arch . ',' . $ct}) {
		print "$file\n";

		open LIST,'<' . $lists_dir{$arch} . '/' . $file;

		while (<LIST>) {
			chop;

			if (/^Package: (.*)$/) {
				$package = $1;
			} elsif (/^[ \t](.*)$/) {
				$value .= "\n " if $needcr;
				$line = $1;
				$line = "" if $line eq ".";
				$value .= $line;
				$db{$arch . ',' . $package . ',' . $property} = $value;
				$needcr = 1;
				if ($isfiles) {
					($md5, $sz, $file) = split(/ /, $line);
					$db{'file,' . $file . ',Package'} = $package;
					$db{'file,' . $file . ',MD5'} = $md5;
					$db{'file,' . $file . ',Size'} = $sz;
				}
			} elsif (/^(.*):$/) {
				$property = $1;
				$isfiles = ($property eq "Files");
				$value = "";
				$needcr = 1;
			} elsif (/^(.*): (.*)$/) {
				$property = $1;
				$isfiles = ($property eq "Files");
				$value = $2;
				$db{$arch . ',' . $package . ',' . $property} = $value;
				$needcr = 1;
				if ($isfiles) {
					($md5, $sz, $file) = split(/ /, $line);
					$db{'file,' . $file . ',Package'} = $package;
					$db{'file,' . $file . ',MD5'} = $md5;
					$db{'file,' . $file . ',Size'} = $sz;
				}
			} elsif (/^$/) {
				$package = "";
			} else {
				$package = "";
				print "Error: ", $_, "\n";
			}
		}

		close LIST;
		$ct++;
	}
}

print "Processing binary (.deb) archives\n";
while (($ffile, $value) = each %binary) {
	($arch, $ver, $pack) = split(/,/, $value);

        if ($ffile =~ m:^.*/([^/]*)$:) {
                $file = $1;
        } else {
                $file = $ffile;
        }

	if ($arch eq "all") {
		@archs = @avl_archs;
	} else {
		@archs = ( $arch );
	}

	$done = 0;
	foreach $try_arch (@archs) {
		$dbarch = $db{$try_arch . ',' . $pack . ',Architecture'};
		$dbver= $db{$try_arch . ',' . $pack . ',Version'};
		$section = $db{$try_arch . ',' . $pack . ',Section'};

		if ($dbver eq $ver) {
			$done = 1;
			last;
		}
	}
	if (!$done) {
		print "Skipping (old) $ffile\n";
		next;
	}

	$shortver = $dbver;
	$shortver =~ s/^[^:]*://;

	$nonus = 0;
	if ($section =~ m:non-US:) {
		$nonus = 1;
		$section = "non-US/main" if ($section eq "non-US");
		$sec = $section;
		$sub = "";
	} elsif ($section =~ m:(.*)/(.*):) {
		$sec = $1;
		$sub = $2;
	} else {
		$sec = "main";
		$sub = $section;
	}

	$dir = $basepath . '/' . $sec . '/binary-' . $dbarch;
	$dir .= '/' . $sub if $sub;
	$path = $dir . '/' . $pack . '_' . $shortver . '.deb';

	if (-e $path) {
		print "Exists: $path\n";
		next;
	}

	print "$file -> $path\n";
	system (("mkdir", "-p", $dir));
	system (($cmd_binary, $ffile, $path))
}

print "Processing source archives\n";
while (($ffile, $file) = each %source) {
	$pack = $db{'file,' . $file . ',Package'};
	if (!$pack) {
		print "Skipping $ffile\n";
		next;
	}
	$size = $db{'file,' . $file . ',Size'};
	$md5 = $db{'file,' . $file . ',MD5'};

	if (-s $ffile != $size) {
		print "$ffile: bad size\n";
		next;
	}

	$section = $db{'source,' . $pack . ',Section'};

	$nonus = 0;
	if ($section =~ m:non-US:) {
		$nonus = 1;
		$section = "non-US/main" if ($section eq "non-US");
		$sec = $section;
		$sub = "";
	} elsif ($section =~ m:(.*)/(.*):) {
		$sec = $1;
		$sub = $2;
	} else {
		$sec = "main";
		$sub = $section;
	}

	$dir = $basepath . '/' . $sec . '/source';
	$dir .= '/' . $sub if $sub;
	$path = $dir . '/' . $file;

	if (-e $path) {
		print "Exists: $path\n";
		next;
	}

	print "$file -> $path\n";
	system (("mkdir", "-p", $dir));
	system (($cmd_source, $ffile, $path))
}

print "Building available archives list\n";
open FIND,"find $basepath -type f |";
while (<FIND>) {
	chop;

	if (/\.deb$/) {
		if (m:^$basepath/([^/]*)/binary-([^/]*)/([^/]*)/([^/_]*)_([^/_]*).deb$:) {
			$sec = $1;
			$arch = $2;
			$sub = $3;
			$pack = $4;
			$ver = $5;
		} elsif (m:^$basepath/non-US/([^/]*)/binary-([^/]*)/([^/_]*)_([^/_]*).deb$:) {
			$sec = 'non-US/' . $1;
			$sub = "";
			$arch = $2;
			$pack = $3;
			$ver = $4;
		}

		if ($arch eq "all") {
			@archs = @avl_archs;
		} else {
			@archs = ( $arch );
		}

		@must_archs = ( );
		$done = 0;
		foreach $try_arch (@archs) {
			#$dbarch = $db{$try_arch . ',' . $pack . ',Architecture'};
			$dbver= $db{$try_arch . ',' . $pack . ',Version'};
			#$section = $db{$try_arch . ',' . $pack . ',Section'};

			if ($dbver eq $ver) {
				$must_archs[@must_archs] = $try_arch;
				$done = 1;
			}
		}
		if (!$done) {
			#print "Extraneous file $_\n";
			next;
		}

		foreach $do_arch (@must_archs) {
			$key = $do_arch . ',' . $sec;
			if ($packages{$key}) {
				$packages{$key} .= ';' . $sub . ',' . $pack;
			} else {
				$packages{$key} = $sub . ',' . $pack;
			}
		}
	} elsif (m:/Packages$: or m:/Sources$:) {
		# lists: ignore
	} else {
		# source
		if (m:^.*/([^/]*)$:) {
			$file = $1;
			$pack = $db{'file,' . $file . ',Package'};
			if (!$pack) {
				#print "Extraneous file $_\n";
				next;
			}

			$section = $db{'source,' . $pack . ',Section'};
			$nonus = 0;
			if ($section =~ m:non-US:) {
				$nonus = 1;
				$section = "non-US/main" if ($section eq "non-US");
				$sec = $section;
				$sub = "";
			} elsif ($section =~ m:(.*)/(.*):) {
				$sec = $1;
				$sub = $2;
			} else {
				$sec = "main";
				$sub = $section;
			}

			$sources{$sec} = 1;
			$key = $sec . ',' . $sub . ',' . $pack;
			if ($sourcefiles{$key}) {
				$sourcefiles{$key} .= ',' . $file;
			} else {
				$sourcefiles{$key} = $file;
			}
		}
	}
}
close FIND;

while (($key, $list) = each %packages) {
	($arch, $sec) = split(/,/, $key);
	print "Packages: $arch $sec\n";

	open PACKAGES,">$basepath/$sec/binary-$arch/Packages";

	foreach $spec (split(/;/, $list)) {
		($sub, $pack) = split(/,/, $spec);

		print PACKAGES "Package: $pack\n";

		$key0 = $arch . ',' . $pack . ',';
		foreach $prop ('Version', 'Priority', 'Section', 'Maintainer',
			'Depends', 'Conflicts', 'Provides', 'Recommends',
			'Suggests', 'Architecture', 'Size', 'MD5sum',
			'Description', 'installed-size') {
			$value = $db{$key0 . $prop};
			print PACKAGES $prop . ': ' . $value . "\n" if $value;
		}

		$shortver = $db{$key . 'Version'};
		$shortver =~ s/^[^:]*://;
		$filename = $dist . '/' . $sec . '/binary-' . $db{$key0 . 'Architecture'} . '/';
		$filename .= $sub . '/' if $sub;
		$filename .= $pack . '_' . $shortver;

		print PACKAGES 'Filename: ' . $filename . "\n";

		print PACKAGES "\n";

		$list = $rest;
	}

	close PACKAGES;
}

while (($section, $ignore) = each %sources) {
	print "Sources: $section\n";

	open SOURCES,">$basepath/$section/source/Sources";

	while (($key, $list) = each %sourcefiles) {
		($sec, $sub, $pack) = split(/,/, $key);
		next if ($sec != $section);

		print SOURCES "Package: $pack\n";

		$key0 = 'source,' . $pack . ',';
		foreach $prop ('Priority', 'Section', 'Version', 'Binary',
			'Maintainer', 'Architecture', 'Standards-Version') {
			$value = $db{$key0 . $prop};
			print SOURCES $prop . ': ' . $value . "\n" if $value;
		}

		$dir = $dist . '/' . $section . '/source';
		$dir .= '/' . $sub if $sub;
		print SOURCES 'Directory: ' . $dir . "\n";

		print SOURCES "Files:\n";
		foreach $file (split(/,/, $list)) {
			$md5 = $db{'file,' . $file . ',MD5'};
			$sz = $db{'file,' . $file . ',Size'};
			print SOURCES ' ' . $md5 . ' ' . $sz . ' ' . $file . "\n";
		}

		print SOURCES "\n";
	}

	close SOURCES;
}

